## kafs-client 0.5

=== Makefile ===
CFLAGS		= -g -O2 -Wall -Wsign-compare
MKDIR		= mkdir
INSTALL		= install
DESTDIR		=
ETCDIR		= /etc
BINDIR		= /usr/bin
LIBEXECDIR	= /usr/libexec
MANDIR		= /usr/share/man
DATADIR		= /usr/share/kafs-client
UNITDIR		= /usr/lib/systemd/system
SPECFILE	= redhat/kafs-client.spec

LNS		:= ln -sf

###############################################################################
#
# Determine the current package version from the specfile
#
###############################################################################
VERSION		:= $(word 2,$(shell grep "^Version:" $(SPECFILE)))
TARBALL		:= kafs-client-$(VERSION).tar
ZTARBALL	:= $(TARBALL).bz2

###############################################################################
#
# Guess at the appropriate word size
#
###############################################################################
BUILDFOR	:= $(shell file /usr/bin/make | sed -e 's!.*ELF \(32\|64\)-bit.*!\1!')-bit

ifeq ($(BUILDFOR),32-bit)
CFLAGS		+= -m32
else
ifeq ($(BUILDFOR),64-bit)
CFLAGS		+= -m64
endif
endif

###############################################################################
#
# Build stuff
#
###############################################################################
all:
	$(MAKE) -C src all

###############################################################################
#
# Install everything
#
###############################################################################
MAN1	:= $(MANDIR)/man1
MAN5	:= $(MANDIR)/man5
MAN7	:= $(MANDIR)/man7
MAN8	:= $(MANDIR)/man8

install: all
	$(MAKE) -C src install
	$(MKDIR) -p -m755 $(DESTDIR)$(MAN1)/
	$(MKDIR) -p -m755 $(DESTDIR)$(MAN5)/
	$(MKDIR) -p -m755 $(DESTDIR)$(MAN7)/
	$(MKDIR) -p -m755 $(DESTDIR)$(MAN8)/
	$(INSTALL) -D -m 0644 man/*.1 $(DESTDIR)$(MAN1)/
	$(INSTALL) -D -m 0644 man/*.5 $(DESTDIR)$(MAN5)/
	$(INSTALL) -D -m 0644 man/*.7 $(DESTDIR)$(MAN7)/
	$(INSTALL) -D -m 0644 man/*.8 $(DESTDIR)$(MAN8)/
	$(INSTALL) -D -m 0644 conf/cellservdb.conf $(DESTDIR)$(DATADIR)/cellservdb.conf
	$(INSTALL) -D -m 0644 conf/client.conf $(DESTDIR)$(ETCDIR)/kafs/client.conf
	$(INSTALL) -D -m 0644 conf/kafs_dns.conf $(DESTDIR)$(ETCDIR)/request-key.d/kafs_dns.conf
	$(INSTALL) -D -m 0644 conf/kafs-config.service $(DESTDIR)$(UNITDIR)/kafs-config.service
	$(INSTALL) -D -m 0644 conf/afs.mount $(DESTDIR)$(UNITDIR)/afs.mount
	$(MKDIR) -m755 $(DESTDIR)$(ETCDIR)/kafs/client.d

###############################################################################
#
# Clean up
#
###############################################################################
clean:
	$(MAKE) -C src clean
	$(RM) debugfiles.list debugsources.list

distclean: clean
	$(MAKE) -C src distclean
	$(RM) -r rpmbuild $(TARBALL)

###############################################################################
#
# Generate a tarball
#
###############################################################################
$(ZTARBALL):
	git archive --prefix=kafs-client-$(VERSION)/ --format tar HEAD | \
	bzip2 -9 >$(ZTARBALL)

tarball: $(ZTARBALL)

###############################################################################
#
# Generate an RPM
#
###############################################################################
SRCBALL	:= rpmbuild/SOURCES/$(TARBALL)
ZSRCBALL := rpmbuild/SOURCES/$(ZTARBALL)

BUILDID	:= .local
rpmver0	:= $(shell rpmspec -q ./redhat/kafs-client.spec --define "buildid $(BUILDID)")
rpmver1	:= $(word 1,$(rpmver0))
rpmver2	:= $(subst ., ,$(rpmver1))
rpmver3	:= $(lastword $(rpmver2))
rpmver4	:= $(patsubst %.$(rpmver3),%,$(rpmver1))
rpmver	:= $(patsubst kafs-client-%,%,$(rpmver4))
SRPM	:= rpmbuild/SRPMS/kafs-client-$(rpmver).src.rpm

RPMBUILDDIRS := \
	--define "_srcrpmdir $(CURDIR)/rpmbuild/SRPMS" \
	--define "_rpmdir $(CURDIR)/rpmbuild/RPMS" \
	--define "_sourcedir $(CURDIR)/rpmbuild/SOURCES" \
	--define "_specdir $(CURDIR)/rpmbuild/SPECS" \
	--define "_builddir $(CURDIR)/rpmbuild/BUILD" \
	--define "_buildrootdir $(CURDIR)/rpmbuild/BUILDROOT"

RPMFLAGS := \
	--define "buildid $(BUILDID)"

rpm: tarball
	mkdir -p rpmbuild
	chmod ug-s rpmbuild
	mkdir -p rpmbuild/{SPECS,SOURCES,BUILD,BUILDROOT,RPMS,SRPMS}
	cp $(ZTARBALL) $(ZSRCBALL)
	rpmbuild -ts $(ZSRCBALL) --define "_srcrpmdir rpmbuild/SRPMS" $(RPMFLAGS)
	rpmbuild --rebuild $(SRPM) $(RPMBUILDDIRS) $(RPMFLAGS)

rpmlint: rpm
	rpmlint $(SRPM) $(CURDIR)/rpmbuild/RPMS/*/kafs-client-{,debuginfo-}$(rpmver).*.rpm

.PHONY: rpmlint rpm tarball $(ZTARBALL)

###############################################################################
#
# Build debugging
#
###############################################################################
show_vars:
	@echo VERSION=$(VERSION)
	@echo TARBALL=$(TARBALL)
	@echo BUILDFOR=$(BUILDFOR)

=== debian/changelog ===
kafs-client (0.5-5) unstable; urgency=medium

  * Disable upstream build code that adds -m32 or -m64 based on the
    dynamically calculated word size. This code is unnecessary on Debian,
    where the default compiler behavior should be used, and causes
    problems on some Debian architectures that don't support -m64. Thanks
    to Yue Gui, Lucas Nussbaum, and wuruilong for the reports.
    (Closes: #976557, #1069757)
  * Add reproducible=+fixfilepath to DEB_BUILD_MAINT_OPTIONS to avoid
    embedding the build path into binaries, which breaks binary
    reproducibility. Thanks to Vagrant Cascadian for the report.
    (Closes: #1020881)
  * Add missing include to the kafs-check-config patch to support using
    the default cell, fixing build failures with GCC 14. Thanks to
    Matthias Klose for the report. (Closes: #1075106)
  * Update standards version to 4.7.0 (no changes required).

 -- Russ Allbery <rra@debian.org>  Mon, 08 Jul 2024 19:09:23 -0700

kafs-client (0.5-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * No source change upload to move systemd units into /usr.
    (Closes: #1072078)

 -- Chris Hofstaedtler <zeha@debian.org>  Fri, 07 Jun 2024 15:07:07 +0200

kafs-client (0.5-4) unstable; urgency=medium

  [ Bill MacAllister ]
  * Update kafs-check-config to use the root cell is not cell is specified
    on the command line.
  * Convert raw man pages to POD for ease of maintenance.
    - aklog-kafs
    - kafs
    - kafs-check-config
    - kafs-client.conf
    - kafs-dns
    - kafs-preload
    - rxrpc
  * Fix various manual page bugs and add additional information.

  [ Russ Allbery ]
  * Use /usr/share/dpkg/pkg-info.mk to get the package version and source
    package name instead of parsing the output of dpkg-parsechangelog.

 -- Russ Allbery <rra@debian.org>  Sun, 05 Feb 2023 12:48:30 -0800

kafs-client (0.5-3) unstable; urgency=medium

  [ Bill MacAllister]
  * Patches from Spencer Olson <olsonse.umich.edu> for aklog-kafs.
    - Fix minimal command line argument parsing
    - Use Chaskiel Grundman s suggestion for switching key
    - Ensure that aklog-kafs frees memory and passes valgrind/memgrind
      leak test.
    - add commandline option to show build version
    - make display_usage use proper exit status
  * Patches from Debian Janitor <janitor@jelmer.uk>
    - Use canonical URL in Vcs-Git.
    - Update standards version to 4.6.0, no changes needed.
  * In aklog-kafs remove the -v, verbose option, and update the -d
    option to be specified multiple times increasing the verbosity
    of the output.
  * Add test for failure to set the default cell and add a message
    describing the remedy.
  * Updates to preload
    - Add -d as a synomyn to -v.
    - Use the same policy for -d as implemented in kafs-aklog, namely
      -d can be specified more than once increasing the level of debug
      messages.
    - Change the verbose routine to always write to syslog.
    - Add display of failure to set rootcell and sysname when debug
      is set.

  [ Russ Allbery ]
  * Fix syntax of Lintian overrides for the current version of Lintian.
  * Update standards version to 4.6.2 (no changes required).
  * Add myself to Uploaders.

 -- Russ Allbery <rra@debian.org>  Mon, 02 Jan 2023 09:50:27 -0800

kafs-client (0.5-2) unstable; urgency=medium

  * Remove 0.4 patch files not needed in 0.5.
  * Add in missing install of the man page for kafs-preload.
  * Install kafs-dns man page.

 -- Bill MacAllister <bill@ca-zephyr.org>  Sat, 18 Jul 2020 22:13:18 +0000

kafs-client (0.5-1) unstable; urgency=medium

  * New upstream version.
  * Adjust patches to match new upstream version.

 -- Bill MacAllister <bill@ca-zephyr.org>  Sun, 05 Jul 2020 08:00:19 +0000

kafs-client (0.4-1) unstable; urgency=medium

  * New upstream version that removes the dependency on OpenSSL.
  * Patches from Russ Allbery to clean up debian build.
  * Added missing man pages for some executables.

 -- Bill MacAllister <bill@ca-zephyr.org>  Sun, 07 Jun 2020 20:48:04 +0000

kafs-client (0.3-1) unstable; urgency=low

  * Initial release. Closes: #933326

 -- Bill MacAllister <bill@ca-zephyr.org>  Sun, 08 Mar 2020 08:20:23 +0000

=== debian/control ===
Source: kafs-client
Section: net
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 libkeyutils-dev,
 libkrb5-dev
Rules-Requires-Root: no
Maintainer: Bill MacAllister <bill@ca-zephyr.org>
Uploaders: Russ Allbery <rra@debian.org>
Standards-Version: 4.7.0
Homepage: https://www.infradead.org/~dhowells/kafs/
Vcs-Git: https://github.com/whm/kafs-client.git
Vcs-Browser: https://github.com/whm/kafs-client

Package: kafs-client
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 keyutils,
Description: basic tools for kAFS and mounter for the AFS dynamic root
 kAFS is a Linux kernel implementation of the AFS file system.  This
 package contains the basic AFS-compatible tools for kAFS and systemd
 scripts to mount the dynamic root on /afs and preload the cell database.

Package: libkafs-client0
Section: libs
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: kAFS tool shared library
 kAFS is a Linux kernel implementation of the AFS file system.  This
 package provides a library of shareable routines for dealing with the
 kAFS filesystem.  These provide things like configuration parsing and DNS
 lookups.

Package: libkafs-client-dev
Section: libdevel
Architecture: any
Depends:
 libkafs-client0 (= ${binary:Version}),
 ${misc:Depends},
Description: Development files for kAFS tool shared library
 kAFS is a Linux kernel implementation of the AFS file system.  This
 package provides the headers and development files for the libkafs_client
 shared library.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow reproducible=+fixfilepath
export DH_VERBOSE = 1

%:
	dh $@

override_dh_auto_install:
	mkdir -p debian/$(DEB_SOURCE)/usr/share/man/man1
	pod2man --release=$(DEB_VERSION) --section 1 \
		--center=$(DEB_SOURCE) man/aklog-kafs.pod \
		> debian/$(DEB_SOURCE)/usr/share/man/man1/aklog-kafs.1
	mkdir -p debian/$(DEB_SOURCE)/usr/share/man/man5
	pod2man --release=$(DEB_VERSION) --section 5 \
		--center=$(DEB_SOURCE) man/kafs-client.conf.pod \
		> debian/$(DEB_SOURCE)/usr/share/man/man5/kafs-client.conf.5
	mkdir -p debian/$(DEB_SOURCE)/usr/share/man/man7
	set -e; for script in kafs rxrpc ; do \
	    pod2man --release=$(DEB_VERSION) --section 7 \
		--center=$(DEB_SOURCE) man/$${script}.pod \
		> debian/$(DEB_SOURCE)/usr/share/man/man7/$${script}.7 ; \
	done
	mkdir -p debian/$(DEB_SOURCE)/usr/share/man/man8
	set -e; for script in kafs-preload kafs-check-config kafs-dns ; do \
	    pod2man --release=$(DEB_VERSION) --section 8 \
		--center=$(DEB_SOURCE) man/$${script}.pod \
		> debian/$(DEB_SOURCE)/usr/share/man/man8/$${script}.8 ; \
	done
	dh_auto_install
	dh_installsystemd --name=afs
